import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;

public class EOSort extends JApplet implements Runnable {

  private static int N = 8; // default is 8
  private static int MAX_DELAY = 2000; // two seconds
  private static int MAX_VALUE = 50; //
  private Thread[] threads;
  private int[] values;
  private Vector v;

  public void init() {
    Random r = new Random();
    String parm = getParameter("N");
    if (parm != null)
      N = Integer.parseInt(parm);
    values = new int[N];
    for (int i=0; i<N; i++)
      values[i] = r.nextInt(MAX_VALUE) + 1;
  }

  public void start() {
    threads = new Thread[N];
    for (int i=0; i<N; i++) {
      threads[i] = new Thread(this, Integer.toString(i));
      threads[i].start();
    }
  }

  public void stop() {
    for (int i=0; i<N; i++) threads[i] = null;
  }

  private void swap(int i, int j) {
    int temp = values[i];
    values[i] = values[j];
    values[j] = temp;
  }

  public void run() {
    while (threads[0] != null) {
      try {
        Thread.currentThread().sleep((int)(MAX_DELAY*Math.random()));
      } catch (InterruptedException e) {}
      int me = Integer.parseInt(Thread.currentThread().getName());
      int left = Math.max(0,me-1);
      int right = Math.min(N-1,me+1);
      boolean change = false;
      if (values[me] > values[right]) {
        swap(me, right); change = true;
      }

      if (values[me] < values[left]) {
        swap(me, left); change = true;
      }
      if (change) repaint();
    }
  }

  public void paint(Graphics g) {
    v = new Vector(N);
    for (int i=0; i<N; i++) v.add(new Integer(values[i]));
    g.clearRect(0, 0, getContentPane().getWidth(), getContentPane().getHeight());
    g.drawString(v.toString(), 0, 30);
  }

}
